// use std::convert::Infallible;
// use std::collections::HashMap;
use warp::{
  // http::{StatusCode},
  http::{method::Method, HeaderMap, HeaderValue},
  Reply, Rejection,
};
use reqenv::ReqEnv;
/*
use crate::topographic_anatomy::defs::{TaStore,TaData,TaQueryFilters,TopographicAnatomy};
use zterton::kloud::utils::{lng_t,get_lang_items_str,load_lang};
//use zterton::models::{AppStore, AppData};

use crate::defs::AppDB;
use crate::auth::defs::{
  AuthError,
  Sessions,
  UserCtx,
  UserMap, 
  WebResult,
  SharedEnforcer,
  BEARER_PREFIX,
  custom_reject
};
*/
// use ::topographic_anatomy::{TopographicAnatomy};
// use ::tracking_point::{TrackingPoint};
// use crate::tracking_point::defs::{TrackingPoint};
//use app_auth::{UserCtx};
use kloud::{
  defs::{
		KloudQueryFilters,
		KloudReqData,
	},
};
use crate::defs::{DataDBs}; // ,CollsData};
/*
|method: http::Method, path: warp::path::FullPath, headers: http::HeaderMap, body| {
  let mut reqenv = http::Request::builder()
      .method(method)
      .uri(path.as_str())
      .body(body)
      .expect("request builder");
  { *reqenv.headers_mut() = headers; }
  req
*/
/*
pub async fn table(
	opts: KloudQueryFilters,
	header: HeaderMap<HeaderValue>,
	method: Method,
	db: DataDBs, 
	prfx: String,
) -> Result<impl Reply, Rejection> {
	let reqenv = ReqEnv::new(db.app, db.auth, header, method, "", "table", &prfx);
	let lang = reqenv.lang();
	let mut ctx = reqenv.ctx();
	let req_context = "";
	let app_ctx: &str;
	if ! req_context.is_empty() && req_context != reqenv.websrvr().default_module.as_str() {
		app_ctx = req_context;
	} else {
		app_ctx = "";
	}
	let lang_items = serde_json::to_string(&LangItems::new("langs/ta","es","yaml"))
		.unwrap_or_else(|_| String::from(""));
	let mut data_hash: HashMap<String, String> = HashMap::new();
	data_hash.insert("lang".to_string(), lang.to_owned());
	data_hash.insert("lang_txt".to_string(), lang_items.to_owned());

	// let allow_origin = reqenv.websrvr().allow_origin;
	match reqenv.user_authentication().await {
		Ok(auth) => {
			dbg!("auth: {}",&auth);
			// let mut res = String::from("");
			// let res = if let Some(name) = query.get("name") {
			// submitted form
			match reqenv.req
				.render_page(
					&mut ctx,
					reqenv.websrvr().templates_path.as_str(),
					"ta_table/index.html",
					"index.html",
					format!("ta_table/{}.toml", lang.to_owned())
						.to_owned()
						.as_str(),
					&mut data_hash,
					app_ctx,
				)
				.await {
				Ok(page) => 
					Ok(warp::http::Response::builder()
					.body(page)
					.into_response()),
					/*
					Ok(warp::reply::with_header(
						warp::http::Response::new(page),
						"Access-Control-Allow-Origin",
						&allow_origin)),
					*/
				Err(err) => 
					Ok(warp::http::Response::builder()
					.body(err.to_string())
					.into_response()),
					/*
					Ok(warp::reply::with_header(
						warp::http::Response::new(err.to_string()),
						"Access-Control-Allow-Origin",
						&allow_origin)),
					*/
				}
		},
		Err(e) => {
			let result = format!("Error: no credentials found");
			println!("{}",e);
			Ok(warp::http::Response::builder()
			.body(result.to_string())
			.into_response())
			/*
			Ok(warp::reply::with_header(
				warp::http::Response::new(result),
				"Access-Control-Allow-Origin",
				&allow_origin))
			*/
		},  
	}
}
*/
pub async fn list(
	_opts: KloudQueryFilters,
	header: HeaderMap<HeaderValue>,
	method: Method,
//  user: UserCtx, 
	db: DataDBs, 
	prfx: String,
//  path: warp::path::FullPath, headers: warp::http::HeaderMap
) -> Result<impl Reply, Rejection> {
//  dbg!("{:#?}",&db);
//  dbg!("{:#?}",&header);
//  dbg!("{:#?}",&opts);
	let reqenv = ReqEnv::new(db.app, db.auth, header, method, "/list", "list", &prfx);
	// if let Some(lang_str) = header.get("accept-language") {
	//   println!("{:?}",&lang_str);
	// }
//  println!("User: {} | {}",&user.user_id,&user.token);

	// println!("LANG: {}",language);
	// if prfx.as_str()  == "ta" {
	//   let cur = db.colls.ta.entries.read();
	// }
	// let allow_origin = reqenv.websrvr().allow_origin;
	match reqenv.user_authentication().await {
		Ok(_auth) => {
			// dbg!("auth: {}",&auth);
			match prfx.as_str() {
				"ta" => {
/*           let data = CollsData::get_ta_entries(db.colls.clone()).await; 
						let data_out: Vec<TopographicAnatomy> = data.iter().enumerate().filter(|(idx,(itm,_))|{
						let mut skip = false;
						if !opts.id.is_empty() && !itm.contains(&opts.id) { skip = true; }
						if opts.start > 0 && idx < &(opts.start as usize) { skip = true; }
						if opts.end > 0 && idx > &(opts.end as usize) { skip = true; }
						!skip
					}).map(|(_,(_,value))| value).cloned().collect();
*/
					let data_out: Vec<String> = Vec::new();
					let result = serde_json::to_string(&data_out).unwrap_or_else(|_| String::from(""));
					Ok(warp::http::Response::builder()
					.body(result.to_string())
					.into_response())
					/*
					Ok(warp::reply::with_header(
							// warp::reply::json(&CollsData::get_ta_entries(db.colls.clone()).await),
							warp::http::Response::new(result),
						//  warp::http::Response::new(body),
								"Access-Control-Allow-Origin",
							&allow_origin))
						// Ok(warp::reply::json(&result))
					*/
					},
				"tp" => { 
					// let result = CollsData::get_tp_entries(db.colls.clone()).await;
/*            let data = CollsData::get_tp_entries(db.colls.clone()).await; 
						let data_out: Vec<TrackingPoint> = data.iter().enumerate().filter(|(idx,(itm,_))|{
						let mut skip = false;
						if !opts.id.is_empty() && !itm.contains(&opts.id) { skip = true; }
						if opts.start > 0 && idx < &(opts.start as usize) { skip = true; }
						if opts.end > 0 && idx > &(opts.end as usize) { skip = true; }
						!skip
					}).map(|(_,(_,value))| value).cloned().collect();
*/
					let data_out: Vec<String> = Vec::new();
					let result = serde_json::to_string(&data_out).unwrap_or_else(|_| String::from(""));
					Ok(warp::http::Response::builder()
					.body(result.to_string())
					.into_response())
					/*
					Ok(warp::reply::with_header(
							// warp::reply::json(&CollsData::get_tp_entries(db.colls.clone()).await),
							warp::http::Response::new(result),
						//  warp::http::Response::new(body),
								"Access-Control-Allow-Origin",
								&allow_origin))
						// Ok(warp::reply::json(&result))
					*/
					},
				_ => {
					//let result="";
					let result = format!("list for '{}' undefined",&prfx);
					// (AuthError::UserNotFoundError.to_string())
					println!("{}",&result);
					Ok(warp::http::Response::builder()
					.body(result.to_string())
					.into_response())
					/*
					Ok(warp::reply::with_header(
						// warp::reply::json(&""),
						warp::http::Response::new(result),
				//  warp::http::Response::new(body),
						"Access-Control-Allow-Origin",
						&allow_origin))
					*/
					},
			}
		},
		Err(e) => {
			let result = format!("Error: no credentials found");
			println!("{}",e);
			Ok(warp::http::Response::builder()
			.body(result.to_string())
			.into_response())
			/*
			Ok(warp::reply::with_header(
				// warp::reply::json(&""),
				warp::http::Response::new(result),
				"Access-Control-Allow-Origin",
				&allow_origin))
			*/
		},
	}
	/*
	let db_appdata = get_db_appdata().await;
	let reqtasks = ReqEnv::new(&db_appdata, req, "data");
	
	// if init at request 
		//if let Err(e) = set_ta_data().await {
		if set_ta_data(&reqtasks.env()).await.is_err() {
			res.render_html_text("Error");
		}
*/
//   warp::reply::json(&result),
//  let body: String = "".to_string();

	// Ok(warp::reply::with_header(
	//   warp::reply::json(&result),
	// //  warp::http::Response::new(body),
	//     "Access-Control-Allow-Origin",
	//     &allow_origin))
	// Ok(warp::reply::json(&result))
}
// warp::generic::Either<(std::string::String,), (std::string::String,)>
// pub async fn create(
//   create: TopographicAnatomy, 
//   db: DataDBs,
//   prfx: String,
// ) -> Result<impl Reply, Rejection> {
//   /*
//     log::debug!("create_ta: {:?}", create);

//     let mut vec = db.ta.lock().await;

//     for ta in vec.iter() {
//         if ta.id == create.id {
//             log::debug!("    -> id already exists: {}", create.id);
//             // ta with id already exists, return `400 BadRequest`.
//             return Ok(StatusCode::BAD_REQUEST);
//         }
//     }

//     // No existing ta with id, so insert and return `201 Created`.
//     vec.push(create);
// */
//     Ok(StatusCode::CREATED)
// }

pub async fn insert(
	_data: KloudReqData,
	header: HeaderMap<HeaderValue>,
	method: Method,
	db: DataDBs,
	prfx: String,
) -> Result<impl Reply, Rejection> {
	#[allow(unused_mut)]
	let mut result = String::from("");
	let reqenv = ReqEnv::new(db.app, db.auth, header, method, "/insert", "insert", &prfx);
	match reqenv.user_authentication().await {
		Ok(_auth) => {
			// dbg!("auth: {}",&auth);
/*
			match prfx.as_str() {
				"ta" => {
					match serde_json::from_str::<TopographicAnatomy>(&data.str_data) {
						Ok(item) =>  {
							if db.colls.ta.entries.read().contains_key(&data.id) {
								if data.id != item.id {
									db.colls.ta.entries.write().remove(&data.id); 
									println!("DELETE topographic_anatomy id: {}",&data.id);
								}
								db.colls.ta.entries.write().insert(item.id.to_owned(), item.to_owned());
								println!("UPDATED topographic_anatomy id: {}",&item.id);
								result = format!("UPDATED: {}",&item.id);
							} else {
								db.colls.ta.entries.write().insert(item.id.to_owned(), item.to_owned());
								println!("CREATED topographic_anatomy id: {}",&item.id);
								result = format!("CREATED: {}",&item.id);
							}
							// TODO create a job
							/*
							let ta_data = CollsData::get_ta_entries(db.colls.clone()).await; 
							let ta_data_dump = serde_yaml::to_string(&ta_data).unwrap_or_else(|_| String::from(""));
							if ta_data_dump != "" {
								let module = reqenv.module();
								let ta_path = format!("{}/{}.{}",&module.store_root,&module.store_path,&module.store_frmt);
								let _fs_res = tokio::fs::write(&ta_path, ta_data_dump).await.map_err(|e| {
									eprint!("error writing file: {}", e);
								});
							}
							*/
						},
						Err(e) => {
							println!("Error parse insert topographic_anatomy: {}",e);
							result = format!("Error parse ta: {}",&e);
						}
					}
				},
				"tp" => { 
					// let result = CollsData::get_tp_entries(db.colls.clone()).await;
					match serde_json::from_str::<TrackingPoint>(&data.str_data) {
						Ok(item) =>  {
							if db.colls.tp.entries.read().contains_key(&data.id) {
								db.colls.tp.entries.write().insert(item.id.to_owned(), item.to_owned());
								println!("UPDATED tracking_point id: {}",&item.id);
								result = format!("UPDATED: {}",&item.id);
							} else {
								db.colls.tp.entries.write().insert(item.id.to_owned(), item.to_owned());
								println!("CREATED tracking_point id: {}",&item.id);
								result = format!("CREATED: {}",&item.id);
							}
						},
						Err(e) => {
							println!("Error {} parse insert : {}",&prfx,e);
							result = format!("ERROR: {} parse insert: '{}'",&prfx,e);
						}
					}
				},
				_ => {
					result = format!("ERROR: list for '{}' undefined",&prfx);
					// (AuthError::UserNotFoundError.to_string())
					println!("{}",&result);
				}
			};
*/				
		},
		Err(e) => {
			let result = format!("Error: no credentials found");
			println!("{}: {}",&result,e);
		},
	}
	let json_res = format!("{{ \"res\": \"{}\"}}", result);
	Ok(warp::http::Response::builder()
		.body(json_res.to_string())
		.into_response())
	// If the for loop didn't return OK, then the ID doesn't exist...
	// Ok(StatusCode::NOT_FOUND)
}

pub async fn delete(
	data: KloudReqData,
	header: HeaderMap<HeaderValue>,
	method: Method,
	db: DataDBs,
	prfx: String,
) -> Result<impl Reply, Rejection> {
		if data.id.is_empty() {
		return Ok(warp::http::Response::builder()
		.body("ERROR: no data".to_string())
		.into_response());
	}
	let result: String;
	let reqenv = ReqEnv::new(db.app, db.auth, header, method, "/delete", "delete", &prfx);
	match reqenv.user_authentication().await {
		Ok(_auth) => {
			result = String::from("DONE");
			// dbg!("auth: {}",&auth);
/*
			match prfx.as_str() {
				"ta" => {
					if db.colls.ta.entries.read().contains_key(&data.id) {
						db.colls.ta.entries.write().remove(&data.id);
						if db.colls.ta.entries.read().contains_key(&data.id) {
							println!("NOT DELETED topographic_anatomy id: {}",&data.id);
							result = format!("ERROR: topographic_anatomy NOT deleted: '{}'",&data.id);
						} else {
							println!("DELETED topographic_anatomy id: {}",&data.id);
							result = format!("DELETED: topographic_anatomy: '{}'",&data.id);
						}
					} else {
						result = format!("ERROR: topographic_anatomy NOT found: '{}'",&data.id);
					}
				},
				"tp" => { 
					if db.colls.tp.entries.read().contains_key(&data.id) {
						db.colls.tp.entries.write().remove(&data.id);
						if db.colls.tp.entries.read().contains_key(&data.id) {
							println!("NOT DELETED tracking_point id: {}",&data.id);
							result = format!("ERROR: tracking_point NOT deleted: '{}'",&data.id);
						} else {
							println!("DELETED tracking_point id: {}",&data.id);
							result = format!("DELETED: tracking_point: '{}'",&data.id);
						}
					} else {
						result = format!("ERROR: topographic_anatomy NOT found: '{}'",&data.id);
					}
				},
				_ => {
					result = format!("ERROR: list for '{}' undefined",&prfx);
					// (AuthError::UserNotFoundError.to_string())
					println!("{}",&result);
				}
			};
*/
		},
		Err(e) => {
			result = format!("Error: no credentials found");
			println!("{}",e);
		},
	}
	let json_res = format!("{{ \"res\": \"{}\"}}", result);
	Ok(warp::http::Response::builder()
		.body(json_res.to_string())
		.into_response())
}